;****strobo

;.def  	=r0	;
;.def		=r1	;
;.def		=r2	;
;.def		=r3	;
;.def		=r4	;
;.def		=r5	;
;.def		=r6	;
;.def		=r7	;
;.def		=r8	;
;.def		=r9	;
.def	temp24L	=r10	;""
.def	temp24H	=r11	; 
.def	temp24G	=r12	;
.def	led21	=r13	;,  2  1
.def	led43	=r14	;--//-- 4  3
.def	led5		=r15	;
.def	dd24L	=r16	;
.def	dd24H	=r17	;
.def	dd24G	=r18	;
.def	lowF		=r19	;, . 
.def	highF	=r20	;, . 
;.def 		=r21	;
;.def			=r22	;
;.def 		=r23	;
;.def			=r24	;
;.def			=r25	;	
.def	knopki	=r26	;
.def	counter	=r27	;
.def	flags	=r28	; 
.def 	temp 	=r29	;
;.def			=r30	;Z-
;.def			=r31	;

;
.equ	ms5		=7 ;5 ms interval
.equ	press 	=0 ;  

;
.equ	fup		=0
.equ	up		=1
.equ	down	=2
.equ	fdown	=3

;***

.equ	AtLED21	=13	;address of tLED
.equ	AtLED5	=15

;*** B
.equ	knop		=0	;. 
.equ	LAMP	=3	; 
.equ	A1		=4	;  
.equ	A2		=5	;
.equ	A3		=6	;
.equ	A4		=7	;.

.include "tn2313def.inc"

.cseg				;CODE segment
.org 0

		rjmp reset	;Reset handler
		nop			;int1
		nop			;int2
		nop			;timer1 capture
		rjmp flash	;Timer1 CompareA
		nop			;timer1 overflow
 		rjmp tick		;timer0 counter overflow (5 ms)
		nop			;USART0 RX Complete
		nop			;USART0,UDR Empty Handler
		nop			;USART0 TX Complete Handler
		nop			;analog
		nop 			; Pin Change Interrupt
		nop 			; Timer1 Compare B Handler
 		nop	 		; Timer0 Compare A Handler
		nop			; Timer0 Compare B Handler
		nop			; USI Start Handler
		nop			; USI Overflow Handler
		nop			; EEPROM Ready Handler
		nop			; Watchdog Overflow Handler

;*****
.org 0x18 table1:	.db	0xc0,0xf9,0xa4,0xb0,0x99,0x92,0x82,0xf8,0x80,0x90
	;digit	                  0       1      2       3      4        5      6       7       8       9  

;***Reset handler

reset:	ser temp		; 
		out DDRD,temp	;  D  
		out PORTD,temp	;  
		ldi temp,0xFC		;  B
		out DDRB,temp
		out PORTB,temp
		ldi temp,RAMEND
		out SPL,temp		;
		ldi temp,0x04		
		out TCCR0,temp
		ldi temp,60		; 0   5 mc 
		out TCNT0,temp	
		ldi temp,0x0B
		out TCCR1B,temp	; 1  6,4us
		ldi temp,0x00
		out TCCR1A,temp	; 
		ldi temp,0x42		; 
		out TIMSK,temp
		ldi temp,0x80
		out ACSR,temp
		out SREG,temp
		sei				
		clr flags
		ldi highF,0x05	;1500 /
		ldi lowF,0xDC
	
start:	rcall rpmtof		;   
		out OCR1AH,dd24H	; 
		out OCR1AL,dd24L	
		rcall binLED		;  
		clr knopki
		cbr flags,0x01		;  
cont:	ldi counter,15		
mcycle:	rcall display		;
		dec counter		; 0,5
		brne mcycle
		rcall buttons		; 
		sbrs flags,press
		rjmp cont			;   
		rjmp start			;  		

;****

buttons:	cpi knopki,0
		breq but_2
		clr counter
		sbrc knopki,7
		ldi counter,0xff
		add lowF,knopki	; 
		adc highF,counter
		sbr flags,0x01		; 
		ldi temp,0x70
		cp lowF,temp		
		ldi temp,0x17
		cpc highF,temp		
		brlt but_1         	; >6000 ?
		ldi highF,0x17
		ldi lowF,0x70
		rjmp but_2
but_1:	ldi temp,0x96
		cp lowF,temp		
		ldi temp,0x00
		cpc highF,temp		
		brge but_2     		; <150 ?
		ldi highF,0
		ldi lowF,0x96
but_2:	ret

;****  24/16 

rpmtof:	ldi dd24G,0x8f		; 9375000
		ldi dd24H,0x0d	;9375000/n(/) =  (  )
		ldi dd24L,0x18
		clr temp
div24:	clr temp24L		; "" 
		clr temp24H
		clr temp24G
		clc				;  
		ldi counter,25	;
d24_1:	rol dd24L		; 
		rol dd24H		; 
		rol dd24G
		dec counter	    	;-1
		brne	d24_2		; 
		ret			        ;return
d24_2:	rol temp24L	    	;    
	   	rol temp24H		; ""
		rol temp24G
		sub temp24L,lowF	;"" = "" - 
		sbc temp24H,highF
		sbc temp24G,temp
		brcc	d24_3		;  <0
		add temp24L,lowF	;""
		adc temp24H,highF
		adc temp24G,temp
		clc				;    -0  
		rjmp	d24_1		;
d24_3:	sec				;   -1  
		rjmp	d24_1

;****       

display:clr ZH 
		cbi PORTB,A4		;(.)
		mov temp,led21	; 
digit1:	cbr flags,0x80		;  5ms
		andi temp,0x0f	; . 4 
		ldi zl,0x30		;=0x18(24) X 2
		add zl,temp	
		lpm temp,z
		out PORTD,temp	; 
		in	temp,PINB	; 
		andi temp,0x01
		brne led1
		ldi knopki,-10
led1:	sbrs flags,ms5	;5 ms ?
		rjmp led1			;,  
		sbi PORTB,A4		;. 1 
		ser temp			; 
		out PORTD,temp
		cbi PORTB,A3
		mov temp,led21	;2 
		swap temp
digit2:	cbr flags,0x80		
		andi temp,0x0f		
		ldi zl,0x30		
		add zl,temp	
		lpm temp,z		
		out PORTD,temp	
		in	temp,PINB	;2 
		andi temp,0x01
		brne led2
		ldi knopki,-1	
led2:	sbrs flags,ms5		
		rjmp led2	
		sbi PORTB,A3
		ser temp	
		out PORTD,temp
		cbi PORTB,A2
		mov temp,led43	;3 
digit3:	cbr flags,0x80	
		andi temp,0x0f	
		ldi zl,0x30		
		add zl,temp	
		lpm temp,z	
	  	out PORTD,temp	
		in	temp,PINB	;3 
		andi temp,0x01
		brne led3
		ldi knopki,1
led3:	sbrs flags,ms5
		rjmp led3
		sbi PORTB,A2
		ser temp
		out PORTD,temp
		cbi PORTB,A1
		mov temp,led43	;4 
		swap temp
digit4:	cbr flags,0x80	
		andi temp,0x0f	
		ldi zl,0x30		
		add zl,temp	
		lpm temp,z
		out PORTD,temp	
		in	temp,PINB	;4 
		andi temp,0x01
		brne led4
		ldi knopki,10
led4:	sbrs flags,ms5
		rjmp led4		
		sbi PORTB,A1
		ser temp
		out PORTD,temp
		ret		

;***** Converter

binLED:	mov temp24L,lowF
		mov temp24H,highF
		ldi counter,16		;	
		clr led21			; ""
		clr led43
		clr led5					
		clr ZH			;ZH =0
bLED_1:	lsl temp24L		;  
		rol temp24H		;  
		rol led21		
		rol led43
		dec counter		
		brne bLED_2		;  0
		ret				
bLED_2:	ldi r30,AtLED5+1	;Z   .  ""
bLED_3:	ld temp,-Z		; (Z-1) 
		subi temp,-$03	;+ 0x03
		sbrc temp,3		;  3  0
		st Z,temp			; 
		ld temp,Z			; (Z)  ( )
		subi temp,-$30	;+ 0x30
		sbrc temp,7		;  7  0
		st Z,temp			
		cpi ZL,AtLED21	;?
		brne bLED_3		
		rjmp bLED_1		

;****   1
flash:	cbi PORTB,LAMP
		nop
		nop
		sbi PORTB,LAMP
		reti
;****   0
tick:	sbr flags,0x80	
		ldi temp,61	
		out TCNT0,temp
		reti			
